unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, FileCtrl, TabNotBk, ExtCtrls, IniFiles,
  Buttons, StrUtils;

type
  TForm2 = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    RadioGroup1: TRadioGroup;
    ColorDialog1: TColorDialog;
    RichEdit1: TRichEdit;
    GroupBox1: TGroupBox;
    ListeRep: TListBox;
    GroupBox6: TGroupBox;
    HotKeyPlay: THotKey;
    HotKeyPrev: THotKey;
    HotKeyNext: THotKey;
    HotKeyVolUp: THotKey;
    HotKeyVolDwn: THotKey;
    GroupBox7: TGroupBox;
    CheckBallon: TCheckBox;
    CheckSousRep: TCheckBox;
    HotKeyShowHide: THotKey;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    GroupBox4: TGroupBox;
    LabelDemoRep: TLabel;
    BtnClFondRep: TButton;
    BtnClTexteRep: TButton;
    BtnClSurvolRep: TButton;
    GroupBox2: TGroupBox;
    LabelDemoListe: TLabel;
    BtnClFondListe: TButton;
    BtnClTexteListe: TButton;
    BtnClPlayingListe: TButton;
    GroupBox5: TGroupBox;
    BtnColorProgress: TButton;
    BtnColorVolume: TButton;
    GroupBox8: TGroupBox;
    ListBoxLangues: TListBox;
    CheckShuffle: TCheckBox;
    ButtonAjouterRep: TBitBtn;
    ButtonSupprRep: TBitBtn;
    BtnSetHotKey: TBitBtn;
    OpenDialog1: TOpenDialog;
    GroupBox9: TGroupBox;
    BtnChangerIcone: TButton;
    BtnIconeDefaut: TButton;
    GroupBox10: TGroupBox;
    BtnAssocier: TBitBtn;
    BtnRetirerAssociation: TBitBtn;
    LabelWeb: TLabel;
    LabelWebVersion: TLabel;
    LabelLicense: TLabel;
    procedure ButtonRepClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LabelDemoRepMouseEnter(Sender: TObject);
    procedure LabelDemoRepMouseLeave(Sender: TObject);
    procedure BtnSetHotKeyClick(Sender: TObject);
    procedure CheckHotKeyClick(Sender: TObject);
    procedure ChangerCouleur(Sender: TObject);
    procedure LabelDemoListeMouseEnter(Sender: TObject);
    procedure LabelDemoListeMouseLeave(Sender: TObject);
    procedure BtnAssocierClick(Sender: TObject);
    procedure CheckAutresClick(Sender: TObject);
    procedure ListBoxLanguesClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtnChangerIconeClick(Sender: TObject);
    procedure LabelWebClick(Sender: TObject);
    procedure LabelWebVersionClick(Sender: TObject);
    procedure LabelWebVersionMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure LabelWebVersionMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LabelLicenseClick(Sender: TObject);
  private
    { Dclarations prives }
    ListeLangue : TSTringList;
  public
    { Dclarations publiques }
  end;

var
  Form2: TForm2;

implementation

uses Unit1, Unit3, Registry, DeKiBulleUtils;

{$R *.dfm}

//============================================================================//
{                  A l'affichage de la form                                    }
//----------------------------------------------------------------------------//
procedure TForm2.FormShow(Sender: TObject);
var
    Ini,IniL : Tinifile;
    i, r     : integer;
    dir      : string;
    Registre : TRegistry;
    sr       : TSearchRec;
begin
            { On affiche "brutalement" la Form1 si elle est cache }
    Form1.AfficheForm(0, True);
            { Mise  jours des couleurs }
    MiseaJoursCouleurs;
            { Gestion de la langue }
    GestionLangue(2);
            { On revient sur l'onglet 0 }
    TabbedNotebook1.PageIndex := 0;
            { On replace la form }
    Left := Form1.Left - Width - 30;
    Top  := Form1.Top + Form1.Height - Height;
    //SetCursorPos(Left + Width div 2, Top + 10); // On dplace la souris

            { Chargement du fichier Ini }
    Ini := Tinifile.Create(FichierIni);
    with Ini do begin
            { Lecture et affichage des Rpertoires de base }
        ListeRep.Clear;
        i := 0;
        while ValueExists('Repertoires', IntToStr(i)) do
        begin
            ListeRep.Items.add(ReadString('Repertoires', IntToStr(i), ''));
            Inc(i);
        end;
            { Initialise les diffrents objets }
        CheckBox1.Checked     := ReadBool('HOTKEYS', 'PlayActive', True);
        CheckBox2.Checked     := ReadBool('HOTKEYS', 'PrevActive', True);
        CheckBox3.Checked     := ReadBool('HOTKEYS', 'NextActive', True);
        CheckBox4.Checked     := ReadBool('HOTKEYS', 'VolUpActive', True);
        CheckBox5.Checked     := ReadBool('HOTKEYS', 'VolDwnActive', True);
        CheckBox6.Checked     := ReadBool('HOTKEYS', 'ShowHideActive', True);
        CheckHotKeyClick(nil);
        HotKeyPlay.HotKey     := ReadInteger('HOTKEYS', 'Play', 16504);
        HotKeyPrev.HotKey     := ReadInteger('HOTKEYS', 'Prev', 16505);
        HotKeyNext.HotKey     := ReadInteger('HOTKEYS', 'Next', 16506);
        HotKeyVolUp.HotKey    := ReadInteger('HOTKEYS', 'VolUp', 16422);
        HotKeyVolDwn.HotKey   := ReadInteger('HOTKEYS', 'VolDwn', 16424);
        HotKeyShowHide.HotKey := ReadInteger('HOTKEYS', 'ShowHide', 16507);
        BtnSetHotKey.Enabled  := False;

        free;
    end;    // end with Ini

    CheckSousRep.Checked := Form1.MenuSousRep.Checked;
    CheckBallon.Checked  := Form1.MenuAfficherBallon.Checked;
    CheckShuffle.Checked := Form1.MenuShuffle.Checked;
    
            { On regarde si le programme est enregistr pour se lancer avec windows }
    Registre := TRegistry.Create;
    With Registre do begin
        RootKey := HKEY_LOCAL_MACHINE;
        OpenKey('SOFTWARE\Microsoft\WINDOWS\CurrentVersion\Run\', False);
        if ReadString('DeKiBulle') = Application.ExeName then
            RadioGroup1.ItemIndex := 0
        else
            RadioGroup1.ItemIndex := 1;
        CloseKey;
        Free;
    end;

            { Liste des langues disponibles }
    dir := ExtractFilePath(Application.ExeName);
    ListeLangue := TStringList.Create;
    ListBoxLangues.Clear;
    r := FindFirst(dir + 'lang-*.ini' , faAnyFile, sr);
    with ListeLangue do begin
        while r = 0 do begin
            Add(dir + sr.Name);
            IniL := TIniFile.Create(Strings[Count - 1]);
            ListBoxLangues.Items.Add(IniL.ReadString('NAME', 'Name', sr.Name));
            if (Strings[Count - 1] = FichierLangue) then
                ListBoxLangues.ItemIndex := Count - 1;
            IniL.Free;
            r := FindNext(sr);
        end;
    end;
    FindClose(sr);
end;

//============================================================================//
{             Clic sur les boutons ajouter ou supprimer rpertoire             }
//----------------------------------------------------------------------------//
procedure TForm2.ButtonRepClick(Sender: TObject);
var
    Ini, IniLangue : Tinifile;
    i              : integer;
    S              : string;
begin
    if (Sender as TBitBtn).Name = 'ButtonAjouterRep' then
    begin
        if SelectDirectory(GroupBox1.Caption, '', S) then
        begin
            if not(AnsiEndsStr('\', S)) then S := S + '\';
            ListeRep.Items.add(S);       // Ajoute un rpertoire de base
        end;
    end else begin
        IniLangue := Tinifile.Create(FichierLangue);
        if MessageDlg(IniLangue.ReadString('MESSAGES', '11', ''), mtConfirmation, [mbYes, mbNo], 0) = mrNo then
        begin
            IniLangue.Free;
            Exit;
        end;
        IniLangue.Free;
        ListeRep.DeleteSelected;   //Supprime un rpertoire de base
    end;

    Ini := Tinifile.Create(FichierIni);    // Charge le fichier Ini
    Ini.EraseSection('Repertoires');       // Efface la liste des rpertoires
    for i := 0 to listerep.Count - 1 do    // Enregistre les rpertoires
        Ini.WriteString('Repertoires', IntToStr(i), listerep.Items[i]);
    Ini.Free;                              // Libre le fichier Ini
    Form1.MiseaJours;                      // On met  jours la TreeView de la Form1
end;

//============================================================================//
{    Active ou Dsactive le lancement du programme avec Windows                }
//----------------------------------------------------------------------------//
procedure TForm2.RadioGroup1Click(Sender: TObject);
Var
    Registre: TRegistry;
begin
    Registre := TRegistry.Create;
    With Registre do
    begin
        RootKey := HKEY_LOCAL_MACHINE;
        OpenKey('SOFTWARE\Microsoft\WINDOWS\CurrentVersion\Run\', True);
        if RadioGroup1.ItemIndex = 0 then
            WriteString('DeKiBulle', Application.ExeName)
        else
            DeleteValue('DeKiBulle');
         CloseKey;
         Free;
    end;
end;

//============================================================================//
{                                                                              }
//----------------------------------------------------------------------------//
procedure TForm2.CheckAutresClick(Sender: TObject);
begin
    With Form1 do begin
        if (Sender as TCheckBox).Name = 'CheckBallon' then
            MenuAfficherBallon.Checked := CheckBallon.Checked
        else if (Sender as TCheckBox).Name = 'CheckSousRep' then
            MenuSousRep.Checked := CheckSousRep.Checked
        else
            MenuShuffle.Checked := CheckShuffle.Checked;
    end;
end;

//============================================================================//
{                  Changements couleurs                                        }
//----------------------------------------------------------------------------//
procedure TForm2.ChangerCouleur(Sender: TObject);
var
    Ini: Tinifile;
begin
            { Change les couleurs }
    Ini := Tinifile.Create(FichierIni);
    with (Sender as TButton) do
    begin
        ColorDialog1.Color := ini.ReadInteger('DATA', Name, 0);
        if ColorDialog1.Execute then
            Ini.WriteInteger('DATA', Name, ColorDialog1.Color);
    end;
    Ini.Free;
    MiseaJoursCouleurs;
end;

//============================================================================//
{                  Changement de l'icone du programme                          }
//----------------------------------------------------------------------------//
procedure TForm2.BtnChangerIconeClick(Sender: TObject);
var
    Ini: Tinifile;
begin
    Ini := Tinifile.Create(FichierIni);
    if (Sender as TButton).Name = 'BtnIconeDefaut' then
        ini.WriteString('DATA', 'Icone', '')
    else
        if OpenDialog1.Execute then
            ini.WriteString('DATA', 'Icone',  OpenDialog1.FileName);
    MiseaJoursCouleurs;
    ini.Free;
end;

//============================================================================//
{                  Survol des textes de dmo                                   }
//----------------------------------------------------------------------------//
procedure TForm2.LabelDemoRepMouseEnter(Sender: TObject);
begin
    LabelDemoRep.Font.Color := Form1.TreeView1.Tag;
    LabelDemoRep.Font.Style := [fsBold, fsUnderline];
end;
procedure TForm2.LabelDemoRepMouseLeave(Sender: TObject);
begin
    LabelDemoRep.Font.Color := Form1.TreeView1.Font.Color;
    LabelDemoRep.Font.Style := [fsBold];
end;
procedure TForm2.LabelDemoListeMouseEnter(Sender: TObject);
begin
    LabelDemoListe.Font.Color := Form1.ListBox1.Tag;
end;
procedure TForm2.LabelDemoListeMouseLeave(Sender: TObject);
begin
    LabelDemoListe.Font.Color := Form1.Listbox1.Font.Color;
end;

//============================================================================//
{                  Changement de langue                                        }
//----------------------------------------------------------------------------//
procedure TForm2.ListBoxLanguesClick(Sender: TObject);
begin
    FichierLangue := ListeLangue.Strings[ListBoxLangues.ItemIndex];
    GestionLangue;
end;

//============================================================================//
{                  Enregistrement des HotKeys                                  }
//----------------------------------------------------------------------------//
procedure TForm2.BtnSetHotKeyClick(Sender: TObject);
var
    Ini: Tinifile;
begin
    BtnSetHotKey.Enabled := False;
    Ini := Tinifile.Create(FichierIni);
    With Ini do
    begin
        WriteBool('HOTKEYS', 'PlayActive', CheckBox1.Checked);
        WriteBool('HOTKEYS', 'PrevActive', CheckBox2.Checked);
        WriteBool('HOTKEYS', 'NextActive', CheckBox3.Checked);
        WriteBool('HOTKEYS', 'VolUpActive', CheckBox4.Checked);
        WriteBool('HOTKEYS', 'VolDwnActive', CheckBox5.Checked);
        WriteBool('HOTKEYS', 'ShowHideActive', CheckBox6.Checked);
        WriteInteger('HOTKEYS', 'Play', HotKeyPlay.HotKey);
        WriteInteger('HOTKEYS', 'Prev', HotKeyPrev.HotKey);
        WriteInteger('HOTKEYS', 'Next', HotKeyNext.HotKey);
        WriteInteger('HOTKEYS', 'VolUp', HotKeyVolUp.HotKey);
        WriteInteger('HOTKEYS', 'VolDwn', HotKeyVolDwn.HotKey);
        WriteInteger('HOTKEYS', 'ShowHide', HotKeyShowHide.HotKey);
        Free;
    end;
    With Form1 do
    begin
        HotKeyManager1.ClearHotKeys;
        if CheckBox1.Checked then
            HotKeyIndexPlay := HotKeyManager1.AddHotKey(HotKeyPlay.HotKey)
        else
            HotKeyIndexPlay := 0;
        if CheckBox2.Checked then
            HotKeyIndexPrev := HotKeyManager1.AddHotKey(HotKeyPrev.HotKey)
        else
            HotKeyIndexPrev := 0;
        if CheckBox3.Checked then
            HotKeyIndexNext := HotKeyManager1.AddHotKey(HotKeyNext.HotKey)
        else
            HotKeyIndexNext := 0;
        if CheckBox4.Checked then
            HotKeyIndexVolUp := HotKeyManager1.AddHotKey(HotKeyVolUp.HotKey)
        else
            HotKeyIndexVolUp := 0;
        if CheckBox5.Checked then
            HotKeyIndexVolDwn := HotKeyManager1.AddHotKey(HotKeyVolDwn.HotKey)
        else
            HotKeyIndexVolDwn := 0;
        if CheckBox6.Checked then
            HotKeyIndexShowHide := HotKeyManager1.AddHotKey(HotKeyShowHide.HotKey)
        else
            HotKeyIndexShowHide := 0;
    end;
end;

//============================================================================//
{                  Activation / Dsactivation des HotKeys                      }
//----------------------------------------------------------------------------//
procedure TForm2.CheckHotKeyClick(Sender: TObject);
begin
    BtnSetHotKey.Enabled   := True;
    HotKeyPlay.Enabled     := CheckBox1.Checked;
    HotKeyPrev.Enabled     := CheckBox2.Checked;
    HotKeyNext.Enabled     := CheckBox3.Checked;
    HotKeyVolUp.Enabled    := CheckBox4.Checked;
    HotKeyVolDwn.Enabled   := CheckBox5.Checked;
    HotKeyShowHide.Enabled := CheckBox6.Checked;
end;

//============================================================================//
{ Associer ou Dsassocier avec les fichiers audio, les rpertoires et les CD Audio }
//----------------------------------------------------------------------------//
procedure TForm2.BtnAssocierClick(Sender: TObject);
var
    i              : integer;
    IniLangue, Ini : TIniFile;
    //Associer       : Boolean;
    FichierIcone   : String;
    Registre       : TRegistry;
begin
    Screen.Cursor := crHourGlass;
    IniLangue := Tinifile.Create(FichierLangue);
    //Associer := ((Sender as TButton).Name = 'BtnAssocier');
    Ini := Tinifile.Create(FichierIni);
    FichierIcone := Ini.ReadString('DATA', 'Icone', '');
    if not(FileExists(FichierIcone)) then
        FichierIcone := Application.ExeName;
    Ini.Free;

    Registre := TRegistry.Create;
    with Registre do
    begin
        RootKey := HKEY_CLASSES_ROOT;
        if ((Sender as TButton).Name = 'BtnAssocier') then
        begin
                    // on cre le type de fichier "dekibulle_file"
            OpenKey('dekibulle_file\shell\open\command', True);
              WriteString('', '"' + Application.ExeName + '"' + ' "%1"');
            CloseKey;
            OpenKey('dekibulle_file\DefaultIcon', True);
              WriteString('', FichierIcone);
            CloseKey;

            if MessageDlg(IniLangue.ReadString('MESSAGES', '13', ''), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
            begin
                    // on associe chaque extension au type de fichier "dekibulle_file"
                For i := Low(VEXT) to High(VEXT) do
                begin
                    OpenKey('.' + VEXT[i], True);
                      WriteString('', 'dekibulle_file');
                    CloseKey;
                end;
                OpenKey('.m3u', True);
                  WriteString('', 'dekibulle_file');
                CloseKey;
            end;

            if MessageDlg(IniLangue.ReadString('MESSAGES', '14', ''), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
            begin
                    // on associe les rpertoires
                OpenKey('Folder\shell\DeKiBulle', True);
                  WriteString('', IniLangue.ReadString('MESSAGES', '12', 'Lire avec DKiBulle'));
                CloseKey;
                OpenKey('Folder\shell\DeKiBulle\command', True);
                  WriteString('', '"' + Application.ExeName + '"' + ' "%1"');
                CloseKey;
            end;

            if MessageDlg(IniLangue.ReadString('MESSAGES', '15', ''), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
            begin
                    // on sauvegarde l'ancienne association puis
                    // on associe les CD Audio
                OpenKey('AudioCD\shell\play\command', False);
                  if not(ValueExists('dekibulle.BAK')) then
                    WriteString('dekibulle.BAK', ReadString(''));
                  WriteString('', '"' + Application.ExeName + '"' + ' "%1"');
                CloseKey;
            end;

        end else begin
            if MessageDlg(IniLangue.ReadString('MESSAGES', '11', ''), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
            begin
                    // on supprime les associations pour chaque extension
                For i := Low(VEXT) to High(VEXT) do
                begin
                    OpenKey('.' + VEXT[i], True);
                      if ReadString('') =  'dekibulle_file' then
                      begin
                          CloseKey;
                          DeleteKey('.' + VEXT[i]);
                      end else
                          CloseKey;
                end;
                OpenKey('.m3u', True);
                  if ReadString('') =  'dekibulle_file' then
                  begin
                      CloseKey;
                      DeleteKey('.m3u');
                  end else
                      CloseKey;

                    // on supprime le type de fichier "dekibulle_file"
                DeleteKey('dekibulle_file\shell\open\command'); //efface le noeud
                DeleteKey('dekibulle_file\shell\open');
                DeleteKey('dekibulle_file\shell');
                DeleteKey('dekibulle_file');

                    // on supprime l'association avec les rpertoires
                DeleteKey('Folder\shell\DeKiBulle\command');
                DeleteKey('Folder\shell\DeKiBulle');

                    // on restaure l'ancienne association avec les CD Audio
                OpenKey('AudioCD\shell\play\command', False);
                  if ValueExists('DeKiBulle.BAK') then
                  begin
                      WriteString('', ReadString('DeKiBulle.BAK'));
                      DeleteValue('DeKiBulle.BAK');
                  end;
                CloseKey;
            end;
        end;
        Free;
    end;
    Beep;
    IniLangue.Free;
    Screen.Cursor := crDefault;
end;

//============================================================================//
{                  Lors de la fermeture de la form                             }
//----------------------------------------------------------------------------//
procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    ListeLangue.Free;
end;

//============================================================================//
{                  Ouvre le site web                                           }
//----------------------------------------------------------------------------//
procedure TForm2.LabelWebClick(Sender: TObject);
begin
    Executer('http://f.montin.free.fr/logiciels');
end;
procedure TForm2.LabelWebVersionClick(Sender: TObject);
begin
    Executer('http://f.montin.free.fr/logiciels/index.php?url=dekibulle/version.html&v=' + Version);
end;
procedure TForm2.LabelWebVersionMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    (Sender as TLabel).Font.Color := clRed;
end;
procedure TForm2.LabelWebVersionMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    (Sender as TLabel).Font.Color := clBlue;
end;

//============================================================================//
{                  Ouvre la licence                                            }
//----------------------------------------------------------------------------//
procedure TForm2.LabelLicenseClick(Sender: TObject);
var
    IniLangue: TIniFile;
    F        : String;
begin
    IniLangue := TiniFile.Create(FichierLangue);
    F := ExtractFilePath(Application.ExeName) + IniLangue.ReadString('OPTION', 'LicenseFile', 'licence-fr.txt');
    IniLangue.Free;
    if FileExists(F) then
        Executer(F);
end;

end.
